<?php
namespace Teknisa\PLA\Modules\Parametros\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use \Teknisa\GER\Services\CrudService;

class Pla03100RestricoesDeOpcoesNoMes extends \Zeedhi\Framework\Controller\Report {
    
    protected $environment;
    protected $crudService;
    protected $qr2Strategy;
    
    public function __construct($reportService, $environment, $crudService, $qr2Strategy) {
        $this->environment = $environment;
        $this->crudService = $crudService;
        $this->qr2Strategy = $qr2Strategy;
        parent::__construct($reportService);
    }
    
    protected $reportMapping = array (
        'PLA03100' => array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
              "CDFILIAL" => "P_CDFILIAL",
              "CDSERVFILI" => "P_CDSERVICO",
              "CDPRATOINI" => "P_CDPRATOINI",
              "CDPRATOFIN" => "P_CDPRATOFIN",
            )
        ),
    );
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response){
        $row = $request->getRow();
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
        if($row['T_NMSERVICO'] == 'T') {
            $conditions = array(
    			array(
    				'columnName' => 'CDFILIAL',
    				'operator' => '=',
    				'value' => $row['CDFILIAL']
    			),
    			array(
    				'columnName' => 'IDTIPOSERV',
    				'operator' => '=',
    				'value' => 'N'
    			),
    				array(
    				'columnName' => 'NRORG',
    				'operator' => '=',
    				'value' => $this->environment->getNrOrg()
    			)
    		);
    		$servicos = $this->crudService->getFilteredDataSet('servico',$conditions)->getRows();
            $cdservfili = '';
            foreach ($servicos as $servico) {
                $cdservfili = $cdservfili . $servico['CDSERVFILI'] . '_';
            }
        } else {
            $cdservfili = '';
            foreach ($row['NMSERVICO'] as $nmservico) {
                $cdservfili = $cdservfili . $nmservico['CDSERVFILI'] . '_';
            }
        }
        $row['CDSERVFILI'] = $cdservfili;
        $row['CDPRATOFIN'] = str_pad($row['CDPRATOFIN'], 10, "z", STR_PAD_RIGHT);

    }

}